
#include <stdio.h>
#include <stdlib.h>


// Parameterübergabe durch Call-by-Reference
// Ist hier nicht sonderlich effizienter als Call-by-Value!
void increment_p(int* p)
{
    // Der Dereferenzierungsoperator * macht den Zugriff
    // auf den eigentlichen Wert möglich.
    (*p) = (*p) + 1;
}

int main()
{

    int ihelp = 42;

    // Der Funktion wird die Adresse der Variablen ihelp übergeben,
    // damit der Parameter der Funktion einen Pointer übergeben bekommt.
    increment_p(&ihelp);

    // Hier muss ihelp nicht dereferenziert werden,
    // da es ja noch immer ein Integer ist!
    printf("42 wird zu %d beim übergeben des Pointers.\n", ihelp);
    
    return EXIT_SUCCESS;

}
