
#include <stdio.h>
#include <stdlib.h>
#include <stdbool.h>
#include <string.h>

// Hinweis zum Verständnis:
// 'char* x' entspricht 'char x[]'


// Definieren des Typs 'suchen_ptr'
typedef char* (*suchen_ptr)(char[]);


char* filter_bieber(char str[])
{
    if(strstr(str, "Bieber")) // 'strstr' ist case-sensitive
    {
        char* result;
        asprintf(&result, "Bieber ist in '%s' enthalten.", str);
        return result;
    }

    return "Suche erfolglos!";
}

char* filter_pendulum(char str[])
{
    if(strstr(str, "Pendulum"))
    {
        char* result;
        asprintf(&result, "Pendulum ist in '%s' enthalten.", str);
        return result;
    }

    return "Suche erfolglos!";
}

// Es muss eine Funktion vom oben definierten Typ 'suchen_ptr' übergeben werden.
char* suchen(suchen_ptr fct, char str[])
{
    // Ruft die übergebene Funktion fct mit dem Parameter str auf.
    return fct(str);
}

int main()
{

    // In der Variablen x wird der Funktionspointer (bzw. die Funktionsadresse) hinterlegt.
    // Dabei muss die Funktion dem oben definierten Typ entsprechen.
    suchen_ptr x = &filter_pendulum;
    // Der Funktion 'suchen' wird die Funktion 'filter_pendulum'
    // und das char-Array "Pendulum" übergeben.
    printf(" --> %s\n", suchen(x, "Pendulum"));
    
    // Alternativ kann man auch folgendes machen:
    // suchen_ptr x = &filter_bieber;
    // printf(" --> %s\n", suchen(x, "Bieber"));
    
    return EXIT_SUCCESS;
}
